diff -uwrN sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2017-12-29 17:04:51.889600100 +1000
+++ source/scripts/jmgUtility.cpp	2018-11-11 08:30:08.535600000 +1000
@@ -9041,6 +9305,1075 @@
 	Commands->Set_Facing(newObject,Commands->Get_Facing(obj));
 	Commands->Destroy_Object(obj);
 }
+SList<JMG_Utility_Basic_Spawner_In_Radius::SpawnObjectNode> JMG_Utility_Basic_Spawner_In_Radius::spawnObjectNodeList;
+void JMG_Utility_Basic_Spawner_In_Radius::Created(GameObject *obj)
+{
+	scriptId = Get_Int_Parameter("Script_ID");
+	if (scriptId == -1)
+		scriptId = this->Get_ID();
+	spawnedObjects = 0;
+	spawnLocation = Get_Vector3_Parameter("Spawn_Location");
+	if (spawnLocation.X == -1.0f && spawnLocation.Y == -1.0f)
+	{
+		Vector3 mypos = Commands->Get_Position(obj);
+		spawnLocation.X = mypos.X;
+		spawnLocation.Y = mypos.Y;
+		if (spawnLocation.Z == -1.0f)
+			spawnLocation.Z = mypos.Z;
+	}
+	spawnAtATime = Get_Int_Parameter("Spawn_At_A_Time");
+	spawnLimit = Get_Int_Parameter("Spawn_Limit");
+	minRadius = Get_Float_Parameter("Min_Spawn_Radius");
+	maxRadius = Get_Float_Parameter("Max_Spawn_Radius");
+	initialSpawnHeight = Get_Float_Parameter("Initial_Spawn_Height");
+	xMultiplier = Get_Float_Parameter("X_Multiplier");
+	yMultiplier = Get_Float_Parameter("Y_Multiplier");
+	rate = Get_Float_Parameter("Spawn_Rate");
+	randomRate = Get_Float_Parameter("Random_Spawn_Rate");
+	collisionCheck = Get_Int_Parameter("Collision_Check")?true:false;
+	retryAttempts = Get_Int_Parameter("Collision_Retry_Attempts");
+	addHeight = Get_Float_Parameter("Collision_Add_Height");
+	changeSpawnCapCustom = Get_Int_Parameter("Change_Spawn_Cap_Custom");
+	sprintf(preset,Get_Parameter("Spawn_Preset"));
+	spawnCount = 0;
+	int initialSpawn = Get_Int_Parameter("Initial_Spawn");
+	if (initialSpawn == -1)
+		initialSpawn = spawnAtATime;
+	pointMustBeInPathfind = Get_Int_Parameter("Point_Must_Be_In_Pathfind")?true:false;
+	manualFacing = Get_Int_Parameter("Manual_Facing")?true:false;
+	faceLocation = Get_Vector3_Parameter("Face_Location");
+	faceDirection = Get_Float_Parameter("Face_Direction");
+	ignoreRayCastFailure = Get_Int_Parameter("Ignore_Ray_Cast_Failure")?true:false;
+	minDistanceBetweenObjects = Get_Float_Parameter("Min_Distance_Between_Objects");
+	minDistanceBetweenObjects *= minDistanceBetweenObjects;
+	spawnGroupId = Get_Int_Parameter("Spawn_Group_ID");
+	for (int x = 0;x < initialSpawn;x++)
+		for (int y = 0;y < 5;y++)
+		{
+			JMG_Utility_Basic_Spawner_In_Radius::SpawnFailureTypes spawnResult = AttemptSpawn(obj);
+			if (spawnResult == SpawnFailureTypes::SUCCESS)
+				break;
+			if (spawnResult == SpawnFailureTypes::LIMIT_REACHED)
+				x = initialSpawn+1;
+		}
+	Commands->Start_Timer(obj,this,rate+(randomRate ? Commands->Get_Random(-randomRate,randomRate) : 0.0f),1);
+}
+void JMG_Utility_Basic_Spawner_In_Radius::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1 && !The_Game()->Is_Game_Over())
+	{
+		JMG_Utility_Basic_Spawner_In_Radius::SpawnFailureTypes spawnResult = AttemptSpawn(obj);
+		if (spawnResult == SpawnFailureTypes::SPAWN_BLOCKED)
+		{
+			Commands->Start_Timer(obj,this,0.1f,1);
+			return;
+		}
+		if (spawnResult == SpawnFailureTypes::SUCCESS)
+			Commands->Start_Timer(obj,this,rate+(randomRate ? Commands->Get_Random(-randomRate,randomRate) : 0.0f),1);
+	}
+}
+void JMG_Utility_Basic_Spawner_In_Radius::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (changeSpawnCapCustom == -1 && message == changeSpawnCapCustom)
+	{
+		spawnAtATime = param;
+	}
+	if (message == 6873523 && param == scriptId)
+	{
+		spawnedObjects++;
+	}
+	if (message == 6873524 && param == scriptId)
+	{
+		spawnedObjects--;
+		Commands->Send_Custom_Event(obj,obj,6873525,scriptId,rate+(randomRate ? Commands->Get_Random(-randomRate,randomRate) : 0.0f));
+	}
+	if (message == 6873525 && param == scriptId)
+	{
+		if (AttemptSpawn(obj) == SpawnFailureTypes::SPAWN_BLOCKED)
+			Commands->Send_Custom_Event(obj,obj,6873525,scriptId,0.1f);
+	}
+}
+JMG_Utility_Basic_Spawner_In_Radius::SpawnFailureTypes JMG_Utility_Basic_Spawner_In_Radius::AttemptSpawn(GameObject *obj)
+{
+	if (!(spawnedObjects < spawnAtATime))
+		return SpawnFailureTypes::LIMIT_REACHED;
+	if (!((spawnLimit >= 0 && spawnCount < spawnLimit) || spawnLimit < 0))
+		return SpawnFailureTypes::LIMIT_REACHED;
+	float distance = (minRadius < maxRadius ? Commands->Get_Random(minRadius,maxRadius) : minRadius);
+	float facing = Commands->Get_Random(-180.0f,180.0f);
+	Vector3 topRay = spawnLocation,bottomRay;
+	topRay.X = spawnLocation.X+cos(facing)*(distance*xMultiplier);
+	topRay.Y = spawnLocation.Y+sin(facing)*(distance*yMultiplier);
+	bottomRay = topRay;
+	topRay.Z = spawnLocation.Z;
+	Vector3 bottom,top;
+	PhysicsSceneClass::Get_Instance()->Get_Level_Extents(bottom,top);
+	if (spawnLocation.Z < bottom.Z)
+		bottomRay.Z = top.Z+1.0f;
+	else
+		bottomRay.Z = bottom.Z-1.0f;
+	CastResultStruct res;
+	res.ComputeContactPoint = true;
+	LineSegClass ray(topRay,bottomRay);
+	PhysRayCollisionTestClass coltest(ray, &res, TERRAIN_ONLY_COLLISION_GROUP);
+	PhysicsSceneClass::Get_Instance()->Cast_Ray(coltest,false);
+	if (coltest.CollidedRenderObj && Vector3::Dot_Product(res.Normal,ray.Get_Dir()) <= 0)
+	{
+		bottomRay.Z = res.ContactPoint.Z+initialSpawnHeight;
+		Vector3 unneeded;
+		if (pointMustBeInPathfind && !Get_Random_Pathfind_Spot(bottomRay,0.0f,&unneeded))
+			return SpawnFailureTypes::SPAWN_BLOCKED;
+		if (CheckIfObjectIsNearAnotherObject(bottomRay))
+			return SpawnFailureTypes::SPAWN_BLOCKED;
+		GameObject *spawned = Commands->Create_Object(preset,bottomRay);
+		if (!spawned)
+		{
+			char errorMsg[220];
+			sprintf(errorMsg,"msg JMG_Utility_Basic_Spawner_In_Radius_Attached ERROR: Preset %s not found!",preset);
+			Console_Input(errorMsg);
+			return SpawnFailureTypes::SPAWN_CODE_ERROR;
+		}
+		if (manualFacing)
+		{
+			if (JmgUtility::SimpleDistance(Vector3(0.0f,0.0f,0.0f),faceLocation) > 0.0f)
+			{
+				Vector3 facePos = faceLocation;
+				facePos.X -= bottomRay.X;
+				facePos.Y -= bottomRay.Y;
+				SetFacing(spawned,atan2(facePos.Y,facePos.X)*(180.0f/PI));
+			}
+			else
+				SetFacing(spawned,faceDirection);
+		}
+		else
+			SetFacing(spawned,Commands->Get_Random(-180.0f,180.0f));
+		if (collisionCheck)
+		{
+			for (int x = 0;x <= retryAttempts;x++)
+			{
+				MoveablePhysClass *mphys = spawned->As_PhysicalGameObj() ? spawned->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : nullptr;
+				if (!mphys)
+				{
+					Console_Input("msg JMG_Utility_Basic_Spawner_In_Radius ERROR: Collision check is turned on but the created object isn't a PhysicalGameObj!");
+					Destroy_Script();
+					return SpawnFailureTypes::SPAWN_CODE_ERROR;
+				}
+				if (!mphys->Can_Teleport(Matrix3D(bottomRay)) || (pointMustBeInPathfind && !Get_Random_Pathfind_Spot(bottomRay,0.0f,&unneeded)))
+				{
+					if (x >= retryAttempts)
+					{
+						Commands->Destroy_Object(spawned);
+						return SpawnFailureTypes::SPAWN_BLOCKED;
+					}
+					bottomRay.Z += addHeight;
+				}
+			}
+			Commands->Set_Position(spawned,bottomRay);
+		}
+		spawnCount++;
+		char params[32];
+		sprintf(params,"%d,%d,%d",Commands->Get_ID(obj),scriptId,spawnGroupId);
+		Commands->Attach_Script(spawned,"JMG_Utility_Basic_Spawner_In_Radius_Attached",params);
+		Commands->Send_Custom_Event(spawned,obj,6873522,6873522,0.0f);
+		return SpawnFailureTypes::SUCCESS;
+	}
+	if (!ignoreRayCastFailure)
+	{
+		Console_Input("msg JMG_Utility_Basic_Spawner_In_Radius_Attached ERROR: Failed to cast Ray!");
+		return SpawnFailureTypes::SPAWN_CODE_ERROR;
+	}
+	return SpawnFailureTypes::SPAWN_BLOCKED;
+}
+bool JMG_Utility_Basic_Spawner_In_Radius::CheckIfObjectIsNearAnotherObject(Vector3 pos)
+{
+	if (minDistanceBetweenObjects <= 0)
+		return false;
+	for (SLNode<SpawnObjectNode> *node = spawnObjectNodeList.Head();node != NULL;node = node->Next())
+	{
+		if (SpawnObjectNode *data = node->Data())
+		{
+			if (!data->obj || (spawnGroupId > 0 && spawnGroupId != data->groupId))
+				continue;
+			if (JmgUtility::SimpleDistance(Commands->Get_Position(data->obj),pos) <= minDistanceBetweenObjects)
+				return true;
+		}
+	}
+	return false;
+}
+void JMG_Utility_Basic_Spawner_In_Radius::SetFacing(GameObject *obj,float facing)
+{
+	if (obj->As_SoldierGameObj())
+	{
+		char params[220];
+		sprintf(params,"0.1,%.2f",facing);
+		Commands->Attach_Script(obj,"JMG_Utility_Delay_Then_Rotate_Camera",params);
+	}
+	else
+		Commands->Set_Facing(obj,facing);
+}
+void JMG_Utility_Basic_Spawner_In_Radius_Attached::Created(GameObject *obj)
+{
+	GameObject *controller = Commands->Find_Object(Get_Int_Parameter("Controller_ID"));
+	if (controller)
+		Commands->Send_Custom_Event(obj,controller,6873523,Get_Int_Parameter("Script_ID"),0.0f);
+	AddSpawnedObjectToGroup(obj);
+}
+void JMG_Utility_Basic_Spawner_In_Radius_Attached::Destroyed(GameObject *obj)
+{
+	GameObject *controller = Commands->Find_Object(Get_Int_Parameter("Controller_ID"));
+	if (controller)
+		Commands->Send_Custom_Event(obj,controller,6873524,Get_Int_Parameter("Script_ID"),0.0f);
+}
+void JMG_Utility_Basic_Spawner_In_Radius_Attached::AddSpawnedObjectToGroup(GameObject *spawned)
+{
+	int spawnGroupId = Get_Int_Parameter("Spawn_Group_ID");
+	if (spawnGroupId == 0)
+		return;
+	for (SLNode<JMG_Utility_Basic_Spawner_In_Radius::SpawnObjectNode> *node = JMG_Utility_Basic_Spawner_In_Radius::spawnObjectNodeList.Head();node != NULL;node = node->Next())
+	{
+		if (JMG_Utility_Basic_Spawner_In_Radius::SpawnObjectNode *data = node->Data())
+		{
+			if (data->obj)
+				continue;
+			data->obj = spawned;
+			data->groupId = spawnGroupId;
+			return;
+		}
+	}
+	JMG_Utility_Basic_Spawner_In_Radius::SpawnObjectNode *node = new JMG_Utility_Basic_Spawner_In_Radius::SpawnObjectNode(spawned,spawnGroupId);
+	JMG_Utility_Basic_Spawner_In_Radius::spawnObjectNodeList.Add_Tail(node);
+}
+void JMG_Utility_Flying_Vehicle_Crash_Apply_Damage::Created(GameObject *obj)
+{
+	subtractMinSpeed = Get_Int_Parameter("Subtract_Min_Speed")?true:false; 
+	minCollisionSpeed = Get_Float_Parameter("Min_Collision_Speed");
+	maxCollisionSpeed = Get_Float_Parameter("Max_Collision_Speed");
+	sprintf(collisionSound,Get_Parameter("Collision_Sound"));
+	sprintf(explosionPreset,Get_Parameter("Explosion_Preset"));
+	allowCrash = false;
+	if (!obj->As_VehicleGameObj())
+	{
+		Console_Input("msg JMG_Utility_Flying_Vehicle_Crash_Apply_Damage ERROR: Must be attached to a vehicle");
+		Destroy_Script();
+		return;
+	}
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Flying_Vehicle_Crash_Apply_Damage::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (!obj->As_PhysicalGameObj()->Is_Attached_To_An_Object())
+		{
+			Vector3 tempSpeed,futurePos;
+			obj->As_VehicleGameObj()->Get_Velocity(tempSpeed);
+			float speed = tempSpeed.Length2()-(subtractMinSpeed?minCollisionSpeed:0.0f);
+			futurePos = Commands->Get_Position(obj);
+			if ((subtractMinSpeed && speed > 0.0f) || speed > minCollisionSpeed)
+			{
+				float facing = Commands->Get_Facing(obj);
+				float positionOffset = (speed/202.336f)*15.0f;
+				futurePos.X += cos(facing*PI180)*positionOffset;
+				futurePos.Y += sin(facing*PI180)*positionOffset;
+				MoveablePhysClass *mphys = obj->As_PhysicalGameObj() ? obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+				if (!mphys || mphys->Can_Teleport(Matrix3D(futurePos)))
+				{
+					if (allowCrash)
+					{
+						allowCrash = false;
+						Commands->Apply_Damage(obj,(speed/maxCollisionSpeed*(Commands->Get_Max_Health(obj)+Commands->Get_Max_Shield_Strength(obj))*0.5f),"None",obj);
+						Commands->Create_Sound(collisionSound,Commands->Get_Position(obj),obj);
+						if (!Commands->Get_Health(obj))
+							Commands->Create_Explosion(explosionPreset,Commands->Get_Position(obj),obj);
+					}
+				}
+				else
+					allowCrash = true;
+			}
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Enemy_Seen_Send_Custom::Created(GameObject *obj)
+{
+	lastEnemyId = 0;
+	seenTime = 0;
+	enemyPresetId = Get_Int_Parameter("Enemy_Preset_ID");
+	id = Get_Int_Parameter("ID");
+	visibleMessage = Get_Int_Parameter("Visible_Message");
+	notVisibleMessage = Get_Int_Parameter("Not_Visible_Message");
+	visibleParam = Get_Int_Parameter("Visible_Param");
+	notVisibleParam = Get_Int_Parameter("Not_Visible_Param");
+	maxNotSeenTime = (int)(Get_Float_Parameter("Max_Lost_Sight_Time")*10);
+	Commands->Enable_Enemy_Seen(obj,true);
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Enemy_Seen_Send_Custom::Enemy_Seen(GameObject *obj,GameObject *seen)
+{
+	if (!JmgUtility::CanSeeStealth(0,obj,seen))
+		return;
+	if (enemyPresetId && enemyPresetId != Commands->Get_Preset_ID(seen))
+		return;
+	if (Is_Script_Attached(seen,"JMG_Utility_Enemy_Seen_Send_Custom_Ignore"))
+		return;
+	int seenId = Commands->Get_ID(seen);
+	if (!seenTime)
+	{
+		GameObject *object = !id ? obj : (id == -1 ? seen : Commands->Find_Object(id));
+		if (object)
+			Commands->Send_Custom_Event(obj,object,visibleMessage,visibleParam,0);
+		lastEnemyId = seenId;
+	}
+	if (lastEnemyId == seenId)
+		seenTime = maxNotSeenTime;
+
+}
+void JMG_Utility_Enemy_Seen_Send_Custom::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (seenTime)
+		{
+			seenTime--;
+			if (!seenTime)
+			{
+				GameObject *object = !id ? obj : (id == -1 ? Commands->Find_Object(lastEnemyId) : Commands->Find_Object(id));
+				if (object)
+					Commands->Send_Custom_Event(obj,object,notVisibleMessage,notVisibleParam,0);
+			}
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Custom_Send_Custom_If_Script_Attached::Created(GameObject *obj)
+{
+	recieveMessage = Get_Int_Parameter("Custom");
+	sprintf(script,"%s",Get_Parameter("Script"));
+}
+void JMG_Utility_Custom_Send_Custom_If_Script_Attached::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == recieveMessage)
+	{
+		if (!Is_Script_Attached(obj,script))
+			return;
+		int id = Get_Int_Parameter("ID");
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+		int Param = Get_Int_Parameter("Param");
+		Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Param == -1 ? param : Param,Get_Float_Parameter("Delay"));
+	}
+}
+void JMG_Utility_Custom_Send_Custom_If_Script_Not_Attached::Created(GameObject *obj)
+{
+	recieveMessage = Get_Int_Parameter("Custom");
+	sprintf(script,"%s",Get_Parameter("Script"));
+}
+void JMG_Utility_Custom_Send_Custom_If_Script_Not_Attached::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == recieveMessage)
+	{
+		if (Is_Script_Attached(obj,script))
+			return;
+		int id = Get_Int_Parameter("ID");
+		GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+		int Param = Get_Int_Parameter("Param");
+		Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("SendCustom"),Param == -1 ? param : Param,Get_Float_Parameter("Delay"));
+	}
+}
+void JMG_Utility_Basic_Spawner_In_Radius_Controller::Destroyed(GameObject *obj)
+{
+	JMG_Utility_Basic_Spawner_In_Radius::spawnObjectNodeList.Remove_All();
+}
+void JMG_Utility_Custom_Set_Engine::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+	enable = Get_Int_Parameter("Enable");
+}
+void JMG_Utility_Custom_Set_Engine::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		Commands->Enable_Engine(obj,(enable == -1 ? param : enable) != 0 ? true : false);
+	}
+}
+void JMG_Utility_Send_Custom_Player_Count_Matches_Preset_Count::Created(GameObject *obj)
+{
+	presetId = Get_Int_Parameter("Preset_ID");
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("Message");
+	param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	rate = Get_Float_Parameter("Rate");
+	minPlayers = Get_Int_Parameter("Min_Player_Count");
+	maxPlayers = Get_Int_Parameter("Max_Player_Count");
+	repeat = Get_Int_Parameter("Repeat") == 0 ? false : true;
+	Commands->Start_Timer(obj,this,rate,1);
+}
+void JMG_Utility_Send_Custom_Player_Count_Matches_Preset_Count::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		int playerCount = Get_Player_Count();
+		if ((minPlayers == -1 || playerCount >= minPlayers) && (maxPlayers == -1 || playerCount <= maxPlayers))
+		{
+			int count = 0;
+			for (SLNode<BaseGameObj> *current = GameObjManager::GameObjList.Head();current;current = current->Next())
+			{
+				GameObject* o = current->Data()->As_ScriptableGameObj();
+				if (Commands->Get_Preset_ID(o) == presetId)
+					count++;
+			}
+			if (count == playerCount)
+			{
+				GameObject *object = !id ? obj : Commands->Find_Object(id);
+				if (object)
+					Commands->Send_Custom_Event(obj,object,custom,param,delay);
+				if (!repeat)
+				{
+					Destroy_Script();
+					return;
+				}
+			}
+		}
+		Commands->Start_Timer(obj,this,rate,1);
+	}
+}
+void JMG_Utility_Custom_Set_Position::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+	position = Get_Vector3_Parameter("Position");
+}
+void JMG_Utility_Custom_Set_Position::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		Commands->Set_Position(obj,position);
+		if (obj->As_ScriptZoneGameObj())
+		{
+			OBBoxClass *zone = Get_Zone_Box(obj);
+			zone->Center = position;
+			JmgUtility::RotateZoneBox(Commands->Get_Facing(obj),zone->Basis);
+			Set_Zone_Box(obj,*zone);
+		}
+	}
+}
+void JMG_Utility_Custom_Delay_Send_Custom::Created(GameObject *obj)
+{
+	watchMessage = Get_Int_Parameter("Custom");
+	id = Get_Int_Parameter("ID");
+	sendMessage = Get_Int_Parameter("SendCustom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	randomDelay = Get_Float_Parameter("RandomDelay");
+	cancelCustom = Get_Int_Parameter("CancelCustom");
+	lastSender = NULL;
+}
+void JMG_Utility_Custom_Delay_Send_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == watchMessage)
+	{
+		Stop_Timer2(obj,this,1);
+		lastSender = sender;
+		lastParam = param;
+		Commands->Start_Timer(obj,this,delay+(randomDelay ? Commands->Get_Random(0.0f,randomDelay) : 0.0f),1);
+	}
+	if (message == cancelCustom)
+	{
+		Stop_Timer2(obj,this,1);
+	}
+}
+void JMG_Utility_Custom_Delay_Send_Custom::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		GameObject *object = id ? (id == -1 ? lastSender : Commands->Find_Object(id)) : obj;
+		Commands->Send_Custom_Event(obj,object,sendMessage,Param == -1 ? lastParam : Param,0);
+	}
+}
+void JMG_Utility_Scale_HP_By_Player_Count::Created(GameObject *obj)
+{
+	maxPlayerCount = Get_Int_Parameter("Max_Player_Count");
+	lastPlayerCount = 1;
+	originalHealth = Commands->Get_Max_Health(obj);
+	originalArmor = Commands->Get_Max_Shield_Strength(obj);;
+	healthMultiplier = Get_Float_Parameter("Health_Multiplier");
+	armorMultiplier = Get_Float_Parameter("Armor_Multiplier");
+	repeat = Get_Int_Parameter("Repeat") == 0 ? false : true;
+	updateScaleCustom = Get_Int_Parameter("UpdateScaleCustom");
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Scale_HP_By_Player_Count::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		RescaleHP(obj);
+		if (!repeat)
+		{
+			Destroy_Script();
+			return;
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Scale_HP_By_Player_Count::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (updateScaleCustom && message == updateScaleCustom)
+	{
+		RescaleHP(obj);
+	}
+}
+void JMG_Utility_Scale_HP_By_Player_Count::RescaleHP(GameObject *obj)
+{
+	int playerCount = maxPlayerCount == -1 ? Get_Player_Count() : min(maxPlayerCount,Get_Player_Count());
+	if (playerCount && lastPlayerCount != playerCount)
+	{
+		float healthRatio = Commands->Get_Health(obj)/Commands->Get_Max_Health(obj);
+		float armorRatio = Commands->Get_Shield_Strength(obj)/Commands->Get_Max_Shield_Strength(obj);
+		Set_Max_Health(obj,healthMultiplier*playerCount*originalHealth);
+		Set_Max_Shield_Strength(obj,armorMultiplier*playerCount*originalArmor);
+		Commands->Set_Health(obj,Commands->Get_Max_Health(obj)*healthRatio);
+		Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj)*armorRatio);
+		lastPlayerCount = playerCount;
+	}
+}
+void JMG_Utility_Custom_Send_Custom_To_All_Objects::Created(GameObject *obj)
+{
+	recieveMessage = Get_Int_Parameter("Custom");
+	team = Get_Int_Parameter("Team");
+	custom = Get_Int_Parameter("SendCustom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+}
+void JMG_Utility_Custom_Send_Custom_To_All_Objects::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == recieveMessage)
+	{
+		for (SLNode<BaseGameObj> *current = GameObjManager::GameObjList.Head();current;current = current->Next())
+		{
+			GameObject* o = current->Data()->As_ScriptableGameObj();
+			if (o && (team == 2 || CheckPlayerType(o,team)))
+ 				Commands->Send_Custom_Event(obj,o,custom,Param == -1 ? param : Param,delay);
+		}
+	}
+}
+void JMG_Utility_Enemy_Seen_Send_Custom_Ignore::Created(GameObject *obj)
+{
+}
+void JMG_Utility_In_Line_Of_Sight_Send_Custom::Created(GameObject *obj)
+{
+	lastEnemyId = 0;
+	enemyPresetId = Get_Int_Parameter("Enemy_Preset_ID");
+	id = Get_Int_Parameter("ID");
+	visibleMessage = Get_Int_Parameter("Visible_Message");
+	notVisibleMessage = Get_Int_Parameter("Not_Visible_Message");
+	visibleParam = Get_Int_Parameter("Visible_Param");
+	notVisibleParam = Get_Int_Parameter("Not_Visible_Param");
+	rate = Get_Float_Parameter("Scan_Rate");
+	enemyOnly = Get_Int_Parameter("Enemy_Only") == 0 ? false : true;
+	Commands->Start_Timer(obj,this,rate,1);
+}
+void JMG_Utility_In_Line_Of_Sight_Send_Custom::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		bool objectSeen = false;
+		for (SLNode<SmartGameObj> *node = GameObjManager::SmartGameObjList.Head();node;node = node->Next())
+		{
+			SmartGameObj* object = node->Data();
+			if (object == obj)
+				continue;
+			if ((!enemyOnly || obj->As_SmartGameObj()->Is_Enemy(object)) && object->Is_Visible() && obj->As_SmartGameObj()->Is_Obj_Visible(object))
+			{
+				if (object->Peek_Physical_Object())
+				{
+					RenderObjClass* model = object->Peek_Physical_Object()->Peek_Model();
+					if (model && model->Is_Hidden())
+						continue;
+				}
+				if (Test_Line_Of_Sight(obj,object))
+					objectSeen = true;
+			}
+		}
+		if (!objectSeen && lastEnemyId)
+		{
+			GameObject *object = !id ? obj : (id == -1 ? Commands->Find_Object(lastEnemyId) : Commands->Find_Object(id));
+			if (object)
+				Commands->Send_Custom_Event(obj,object,notVisibleMessage,notVisibleParam,0);
+			lastEnemyId = 0;
+		}
+		Commands->Start_Timer(obj,this,rate,1);
+	}
+}
+bool JMG_Utility_In_Line_Of_Sight_Send_Custom::Test_Line_Of_Sight(GameObject *obj,GameObject *seen)
+{
+	if (!JmgUtility::CanSeeStealth(0,obj,seen))
+		return false;
+	if (enemyPresetId && enemyPresetId != Commands->Get_Preset_ID(seen))
+		return false;
+	if (Is_Script_Attached(seen,"JMG_Utility_In_Line_Of_Sight_Send_Custom_Ignore"))
+		return false;
+	int seenId = Commands->Get_ID(seen);
+	if (!lastEnemyId)
+	{
+		GameObject *object = !id ? obj : (id == -1 ? seen : Commands->Find_Object(id));
+		if (object)
+			Commands->Send_Custom_Event(obj,object,visibleMessage,visibleParam,0);
+		lastEnemyId = seenId;
+		return true;
+	}
+	if (lastEnemyId == seenId)
+		return true;
+	return false;
+}
+void JMG_Utility_In_Line_Of_Sight_Send_Custom_Ignore::Created(GameObject *obj)
+{
+}
+void JMG_Utility_Timer_Trigger_Enemy_Seen::Created(GameObject *obj)
+{
+	rate = Get_Float_Parameter("Scan_Rate");
+	Commands->Start_Timer(obj,this,rate,1);
+}
+void JMG_Utility_Timer_Trigger_Enemy_Seen::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		for (SLNode<SmartGameObj> *node = GameObjManager::SmartGameObjList.Head();node;node = node->Next())
+		{
+			SmartGameObj* object = node->Data();
+			if (object == obj)
+				continue;
+			if (obj->As_SmartGameObj()->Is_Enemy(object) && object->Is_Visible() && obj->As_SmartGameObj()->Is_Obj_Visible(object))
+			{
+				if (object->Peek_Physical_Object())
+				{
+					RenderObjClass* model = object->Peek_Physical_Object()->Peek_Model();
+					if (model && model->Is_Hidden())
+						continue;
+				}
+				const SimpleDynVecClass<GameObjObserverClass *> & observer_list = obj->Get_Observers();
+				for(int index = 0;index < observer_list.Count();index++)
+					observer_list[index]->Enemy_Seen(obj,object);
+			}
+		}
+		Commands->Start_Timer(obj,this,rate,1);
+	}
+}
+void JMG_Utility_Custom_Teleport_To_Random_Wander_Point::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+	retryOnFailure = Get_Int_Parameter("RetryOnFailure") ? true : false;
+	safeTeleportDistance = Get_Float_Parameter("SafeTeleportDistance");
+	wanderPointGroup = Get_Int_Parameter("WanderingAIGroupID");
+}
+void JMG_Utility_Custom_Teleport_To_Random_Wander_Point::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		Grab_Teleport_Spot(obj,5);
+	}
+}
+bool JMG_Utility_Custom_Teleport_To_Random_Wander_Point::Grab_Teleport_Spot(GameObject *enter,int attempts)
+{
+	if (The_Game()->Get_Game_Duration_S() < 1.0f)
+	{
+		char params[220];
+		sprintf(params,"%d,%.2f",wanderPointGroup,safeTeleportDistance);
+		Commands->Attach_Script(enter,"JMG_Utility_Zone_Teleport_To_Random_Wander_Point_Attach",params);
+		return false;
+	}
+	if (!attempts)
+	{
+		if (retryOnFailure)
+		{
+			char params[220];
+			sprintf(params,"%d,%.2f",wanderPointGroup,safeTeleportDistance);
+			Commands->Attach_Script(enter,"JMG_Utility_Zone_Teleport_To_Random_Wander_Point_Attach",params);
+		}
+		return false;
+	}
+	attempts--;
+	Vector3 targetPos;
+	float facing;
+	if (!Get_A_Defense_Point(&targetPos,&facing))
+	{
+		char errormsg[220];
+		sprintf(errormsg,"msg JMG_Utility_Custom_Teleport_To_Random_Wander_Point ERROR: No wander points found for group %d!",wanderPointGroup);
+		Console_Input(errormsg);
+		return false;
+	}
+	MoveablePhysClass *mphys = enter->As_PhysicalGameObj() ? enter->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+	if (mphys && mphys->Find_Teleport_Location(targetPos,safeTeleportDistance,&targetPos))
+	{
+		Toggle_Fly_Mode(enter);
+		Commands->Set_Position(enter,targetPos);
+		Force_Position_Update(enter);
+		Toggle_Fly_Mode(enter);
+		char params[220];
+		sprintf(params,"0.1,%.2f",facing);
+		Commands->Attach_Script(enter,"JMG_Utility_Delay_Then_Rotate_Camera",params);
+		return true;
+	}
+	else
+	{
+		Commands->Set_Position(enter,targetPos);
+		return Grab_Teleport_Spot(enter,attempts);
+	}
+}
+void JMG_Utility_Send_Custom_If_Not_Moving_Enough::Created(GameObject *obj)
+{
+	resetTime = time = (int)(Get_Float_Parameter("Time")*10);
+	distance = Get_Float_Parameter("Distance");
+	distance *= distance;
+	lastPos = Commands->Get_Position(obj);
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("SendCustom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Send_Custom_If_Not_Moving_Enough::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		if (JmgUtility::SimpleDistance(Commands->Get_Position(obj),lastPos) < distance)
+		{
+			time--;
+			if (!time)
+			{
+				GameObject *object = id ? Commands->Find_Object(id) : obj;
+ 				Commands->Send_Custom_Event(obj,object,custom,Param,delay);
+			}
+			if (time < 0)
+				time = resetTime;
+		}
+		else
+		{
+			lastPos = Commands->Get_Position(obj);
+			time = resetTime;
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionSystem JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionControl[128] = {HerdAnimalPositionSystem()};
+void JMG_Utility_AI_Skittish_Herd_Animal::Created(GameObject *obj)
+{
+	weaponRange = 3.75;
+	sprintf(defaultWeapon,"%s",Get_Current_Weapon(obj));
+	int minHerdId = Get_Int_Parameter("MinHerdID");
+	int maxHerdId = Get_Int_Parameter("MaxHerdID");
+	wanderPointGroup = Get_Int_Parameter("WanderGroupID");
+	if (minHerdId > 128 || maxHerdId > 128)
+	{
+		Console_Input("msg JMG_Utility_AI_Skittish_Herd_Animal ERROR: Herd ID must not exceed 128!");
+		Destroy_Script();
+		return;
+	}
+	minRetreatRange = Get_Float_Parameter("MinRetreatRange");
+	maxRetreatRange = Get_Float_Parameter("MaxRetreatRange");
+	wanderRadiusAroundHerdCenter = Get_Float_Parameter("WanderRadiusAroundHerdCenter");
+	wanderRadiusAroundHerdCenterSq = wanderRadiusAroundHerdCenter+10.0f;
+	wanderRadiusAroundHerdCenterSq *= wanderRadiusAroundHerdCenterSq;
+	minWanderFrequency = Get_Float_Parameter("MinWanderFrequency");
+	maxWanderFrequency = Get_Float_Parameter("MaxWanderFrequency");
+	minRetreatTime = Get_Float_Parameter("MinRetreatTime")*1000.0f;
+	maxRetreatTime = Get_Float_Parameter("MaxRetreatTime")*1000.0f;
+	minUpdateHerdCenter = Get_Float_Parameter("MinUpdateHerdCenter")*1000.0f;
+	maxUpdateHerdCenter = Get_Float_Parameter("MaxUpdateHerdCenter")*1000.0f;
+	runTowardThreatChance = Get_Float_Parameter("RunTowardThreatChance");
+	herdId = minHerdId == maxHerdId ? maxHerdId : Commands->Get_Random_Int(minHerdId,maxHerdId);
+	HerdPositionNode = HerdAnimalPositionControl[herdId].AddNode(obj);
+	Commands->Enable_Enemy_Seen(obj,true);
+	Commands->Start_Timer(obj,this,1.1f,1);
+	Commands->Start_Timer(obj,this,1.1f,2);
+}
+void JMG_Utility_AI_Skittish_Herd_Animal::Enemy_Seen(GameObject *obj,GameObject *seen)	
+{
+	if (((HerdAnimalPositionControl[herdId].checkRetreatCloseEnough() || difftime(clock(),HerdAnimalPositionControl[herdId].herdRetreatStart) > HerdAnimalPositionControl[herdId].herdRetreatTime)))
+		setRetreatLocation(obj,seen);
+}
+void JMG_Utility_AI_Skittish_Herd_Animal::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1 && Commands->Get_Health(obj))
+	{
+		if (HerdPositionNode)
+			HerdPositionNode->pos = Commands->Get_Position(obj);
+		if (difftime(clock(),HerdAnimalPositionControl[herdId].herdRetreatStart) < HerdAnimalPositionControl[herdId].herdRetreatTime)
+		{
+			Vector3 pos = Commands->Get_Position(obj);
+			if (JmgUtility::SimpleDistance(pos,HerdAnimalPositionControl[herdId].herdRetreatLocation) < wanderRadiusAroundHerdCenterSq)
+			{
+				pos = HerdAnimalPositionControl[herdId].herdRetreatLocation;
+				float randomRot = Commands->Get_Random(-180.0f,180.0f);
+				float dist = Commands->Get_Random(0.0f,wanderRadiusAroundHerdCenter);
+				pos.X += cos(randomRot)*dist;
+				pos.Y += sin(randomRot)*dist;
+				Vector3 finalPos;
+				if (Get_Random_Pathfind_Spot(pos,wanderRadiusAroundHerdCenter,&finalPos))
+					pos = finalPos;
+			}
+			else
+				pos = HerdAnimalPositionControl[herdId].herdRetreatLocation;
+			GotoLocation(obj,pos,NULL,1.25f);
+			if (HerdAnimalPositionControl[herdId].checkRetreatSuccessful())
+				HerdAnimalPositionControl[herdId].herdRetreatTime = 0;
+		}
+		Commands->Start_Timer(obj,this,1.0f,1);
+	}
+	if (number == 2)
+	{
+		if (difftime(clock(),HerdAnimalPositionControl[herdId].herdRetreatStart) > HerdAnimalPositionControl[herdId].herdRetreatTime)
+		{
+			const char *weap = Get_Current_Weapon(obj);
+			if (weap && !_stricmp(weap,defaultWeapon))
+			{
+				Commands->Select_Weapon(obj,"");
+				Commands->Select_Weapon(obj,defaultWeapon);
+			}
+		}
+		Vector3 pos = HerdAnimalPositionControl[herdId].getCenterLocation(true,wanderPointGroup,minUpdateHerdCenter,maxUpdateHerdCenter);
+		float randomRot = Commands->Get_Random(-180.0f,180.0f);
+		float dist = Commands->Get_Random(0.0f,wanderRadiusAroundHerdCenter);
+		pos.X += cos(randomRot)*dist;
+		pos.Y += sin(randomRot)*dist;
+		Vector3 finalPos;
+		if (Get_Random_Pathfind_Spot(pos,wanderRadiusAroundHerdCenter,&finalPos))
+			GotoLocation(obj,finalPos,NULL);
+		else
+			GotoLocation(obj,pos,NULL);
+		Commands->Start_Timer(obj,this,Commands->Get_Random(minWanderFrequency,maxWanderFrequency),2);
+	}
+}
+void JMG_Utility_AI_Skittish_Herd_Animal::Damaged(GameObject *obj,GameObject *damager,float damage)
+{
+	if (damager && damage > 0 && (herdId && (HerdAnimalPositionControl[herdId].checkRetreatCloseEnough() || difftime(clock(),HerdAnimalPositionControl[herdId].herdRetreatStart) > HerdAnimalPositionControl[herdId].herdRetreatTime)))
+		setRetreatLocation(obj,damager);
+}
+void JMG_Utility_AI_Skittish_Herd_Animal::Destroyed(GameObject *obj)
+{
+	HerdAnimalPositionControl[herdId] -= obj;
+}
+void JMG_Utility_AI_Skittish_Herd_Animal::GotoLocation(GameObject *obj,const Vector3 &pos,GameObject *Enemy,float speed)
+{
+	ActionParamsStruct params;
+	Commands->Get_Action_Params(obj,params);
+	params.Set_Basic(this,100,1);
+	params.Set_Movement(pos,speed ? speed : (Enemy ? 1.0f : Commands->Get_Random(0.25f,1.0f)),Enemy ? weaponRange*Commands->Get_Random(0.01f,1.0f) : 1.0f,false);
+	params.MovePathfind = true;
+	Vector3 mypos = Commands->Get_Position(obj);
+	if (!speed && JmgUtility::SimpleDistance(mypos,pos) < 625 && Commands->Get_Random(0.0f,1.0f) < 0.25f)
+	{
+		params.MoveCrouched = true;
+		params.AttackCrouched = true;
+	}
+	Commands->Action_Goto(obj,params);
+}
+void JMG_Utility_AI_Skittish_Herd_Animal::setRetreatLocation(GameObject *obj,GameObject *enemy)
+{
+	Vector3 pos = Commands->Get_Position(obj);
+	Vector3 mypos = Commands->Get_Position(enemy);
+	pos.X -= mypos.X;
+	pos.Y -= mypos.Y;
+	float TempRotation = atan2(pos.Y,pos.X);
+	float dist = Commands->Get_Random(minRetreatRange,maxRetreatRange);
+	if (Commands->Get_Random(0.0f,1.0f) < runTowardThreatChance)
+		dist *= -1.0f;
+	pos.X += cos(TempRotation)*dist;
+	pos.Y += sin(TempRotation)*dist;
+	if (Get_A_Wander_Point(&pos,wanderPointGroup))
+	{
+		HerdAnimalPositionControl[herdId].herdRetreatLocation = pos;
+		HerdAnimalPositionControl[herdId].herdRetreatTime = Commands->Get_Random(minRetreatTime,maxRetreatTime);
+		HerdAnimalPositionControl[herdId].herdRetreatStart = clock();
+	}
+	GotoLocation(obj,pos,NULL,1.25f);
+}
+Vector3 JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionSystem::getCenterLocation(bool allowWander,int wanderPointGroup,float minUpdateHerdCenter,float maxUpdateHerdCenter)
+{
+	if (difftime(clock(),herdRetreatStart) < herdRetreatTime)
+		return herdRetreatLocation;
+	if (difftime(clock(),lastPosCalcTime) < minUpdateDelay && hascalculatedPos)
+		return centerPos;
+	minUpdateDelay = Commands->Get_Random(minUpdateHerdCenter,maxUpdateHerdCenter);
+	hascalculatedPos = true;
+	lastPosCalcTime = clock();
+	if (allowWander && Commands->Get_Random(0.00,1.00) < 0.1f && JMG_Utility_AI_Skittish_Herd_Animal::Get_A_Wander_Point(&centerPos,wanderPointGroup))
+		return centerPos;
+	HerdPositionNode *Current = HerdPositionNodeList;
+	Vector3 activePos;
+	int activeCount = 0;
+	while (Current)
+	{
+		if (Current->alive)
+		{
+			activeCount++;
+			activePos += Current->pos;
+		}
+		Current = Current->next;			
+	}
+	if (!activeCount)
+	{
+		JMG_Utility_AI_Skittish_Herd_Animal::Get_A_Wander_Point(&centerPos,wanderPointGroup);
+		return centerPos;
+	}
+	centerPos.X = activePos.X/activeCount;
+	centerPos.Y = activePos.Y/activeCount;
+	centerPos.Z = activePos.Z/activeCount;
+	return centerPos;
+}
+void JMG_Utility_AI_Skittish_Herd_Animal_Ignore::Created(GameObject *obj)
+{
+}
+void JMG_Utility_AI_Skittish_Herd_Animal_Controller::Destroyed(GameObject *obj)
+{
+	for (int x = 0;x < 128;x++)
+		JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionControl[x].Empty_List();
+}
+void JMG_Utility_Custom_Display_Dialog_Box::Created(GameObject *obj)
+{
+	custom = Get_Int_Parameter("Custom");
+	textMessage = newstr(Get_Parameter("Message"));
+	char delim = Get_Parameter("Delim")[0];
+	unsigned int length = strlen(textMessage);
+	for (unsigned int x = 0;x < length;x++)
+		if (textMessage[x] == delim)
+			textMessage[x] = ',';
+}
+void JMG_Utility_Custom_Display_Dialog_Box::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == custom)
+	{
+		char dialog[1000];
+		sprintf(dialog,"pamsg %d %s",JmgUtility::JMG_Get_Player_ID(obj),textMessage);
+		Console_Input(dialog);
+	}
+}
+void JMG_Utility_Custom_Send_Custom_On_Preset_Count::Created(GameObject *obj)
+{
+	recieveMessage = Get_Int_Parameter("Custom");
+	presetId = Get_Int_Parameter("PresetID");
+	minCount = Get_Int_Parameter("MinCount");
+	maxCount = Get_Int_Parameter("MaxCount");
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("SendCustom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+}
+void JMG_Utility_Custom_Send_Custom_On_Preset_Count::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == recieveMessage)
+	{
+		int count = 0;
+		for (SLNode<BaseGameObj> *current = GameObjManager::GameObjList.Head();current;current = current->Next())
+		{
+			GameObject* o = current->Data()->As_ScriptableGameObj();
+			if (Commands->Get_Preset_ID(o) == presetId)
+				count++;
+		}
+		if (count >= minCount && (maxCount == -1 || count <= maxCount))
+		{
+			GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+ 			Commands->Send_Custom_Event(obj,object,custom,Param == -1 ? param : Param,delay);
+		}
+	}
+}
+void JMG_Utility_Custom_Send_Custom_On_Script_Count::Created(GameObject *obj)
+{
+	recieveMessage = Get_Int_Parameter("Custom");
+	sprintf(script,"%s",Get_Parameter("Script"));
+	minCount = Get_Int_Parameter("MinCount");
+	maxCount = Get_Int_Parameter("MaxCount");
+	id = Get_Int_Parameter("ID");
+	custom = Get_Int_Parameter("SendCustom");
+	Param = Get_Int_Parameter("Param");
+	delay = Get_Float_Parameter("Delay");
+}
+void JMG_Utility_Custom_Send_Custom_On_Script_Count::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (message == recieveMessage)
+	{
+		int count = 0;
+		for (SLNode<BaseGameObj> *current = GameObjManager::GameObjList.Head();current;current = current->Next())
+		{
+			GameObject* o = current->Data()->As_ScriptableGameObj();
+			if (Is_Script_Attached(o,script))
+				count++;
+		}
+		if (count >= minCount && (maxCount == -1 || count <= maxCount))
+		{
+			GameObject *object = id ? (id == -1 ? sender : Commands->Find_Object(id)) : obj;
+ 			Commands->Send_Custom_Event(obj,object,custom,Param == -1 ? param : Param,delay);
+		}
+	}
+}
+
+void JMG_Utility_Poke_Send_Custom_From_Poker::Created(GameObject *obj)
+{
+	Commands->Enable_HUD_Pokable_Indicator(obj,true);
+}
+void JMG_Utility_Poke_Send_Custom_From_Poker::Poked(GameObject *obj, GameObject *poker)
+{
+	if (CheckPlayerType(poker,Get_Int_Parameter("PlayerType")) || Commands->Get_Player_Type(poker) == -4)
+		return;
+	int id = Get_Int_Parameter("ID");
+	GameObject *object = id ? (id == -1 ? poker : Commands->Find_Object(id)) : obj;
+	if (object)
+		Commands->Send_Custom_Event(poker,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+	if (Get_Int_Parameter("TriggerOnce"))
+	{
+		Commands->Enable_HUD_Pokable_Indicator(obj,false);
+		Destroy_Script();
+	}
+}
+void JMG_Utility_Custom_Grant_Scaled_Score::Created(GameObject *obj)
+{
+	maxPlayerCount = Get_Int_Parameter("MaxPlayerCount");
+	lastPlayerCount = 1;
+	theScore = score = Get_Float_Parameter("Score");
+	scoreMultiplier = Get_Float_Parameter("ScoreMultiplier");
+	repeat = Get_Int_Parameter("Repeat") == 0 ? false : true;
+	grantCustom = Get_Int_Parameter("GrantCustom");
+	updateScaleCustom = Get_Int_Parameter("UpdateScaleCustom");
+	stopUpdateCustom = Get_Int_Parameter("StopUpdateCustom");
+	grantToSender = Get_Int_Parameter("GrantToSender") == 0 ? false : true;
+	entireTeam = Get_Int_Parameter("EntireTeam") == 0 ? false : true;
+	Commands->Start_Timer(obj,this,0.1f,1);
+}
+void JMG_Utility_Custom_Grant_Scaled_Score::Timer_Expired(GameObject *obj,int number)
+{
+	if (number == 1)
+	{
+		RescaleScore(obj);
+		if (!repeat)
+		{
+			Destroy_Script();
+			return;
+		}
+		Commands->Start_Timer(obj,this,0.1f,1);
+	}
+}
+void JMG_Utility_Custom_Grant_Scaled_Score::Custom(GameObject *obj,int message,int param,GameObject *sender)
+{
+	if (grantCustom && message == grantCustom)
+	{
+		Commands->Give_Points(grantToSender ? sender : obj,theScore,entireTeam);
+	}
+	if (updateScaleCustom && message == updateScaleCustom)
+	{
+		RescaleScore(obj);
+	}
+	if (stopUpdateCustom && message == stopUpdateCustom)
+	{
+		Stop_Timer2(obj,this,1);
+	}
+}
+void JMG_Utility_Custom_Grant_Scaled_Score::RescaleScore(GameObject *obj)
+{
+	int playerCount = maxPlayerCount == -1 ? Get_Player_Count() : min(maxPlayerCount,Get_Player_Count());
+	if (playerCount && lastPlayerCount != playerCount)
+	{
+		theScore = score*scoreMultiplier*playerCount;
+		lastPlayerCount = playerCount;
+	}
+}
 ScriptRegistrant<JMG_Utility_Check_If_Script_Is_In_Library> JMG_Utility_Check_If_Script_Is_In_Library_Registrant("JMG_Utility_Check_If_Script_Is_In_Library","ScriptName:string,CppName:string");
 ScriptRegistrant<JMG_Send_Custom_When_Custom_Sequence_Matched> JMG_Send_Custom_When_Custom_Sequence_Matched_Registrant("JMG_Send_Custom_When_Custom_Sequence_Matched","Success_Custom=0:int,Correct_Step_Custom=0:int,Partial_Failure_Custom=0:int,Failure_Custom=0:int,Send_To_ID=0:int,Custom_0=0:int,Custom_1=0:int,Custom_2=0:int,Custom_3=0:int,Custom_4=0:int,Custom_5=0:int,Custom_6=0:int,Custom_7=0:int,Custom_8=0:int,Custom_9=0:int,Disable_On_Success=1:int,Disable_On_Failure=0:int,Starts_Enabled=1:int,Enable_Custom=0:int,Correct_Step_Saftey=0:int,Failure_Saftey=1:int,Max_Failures=1:int");
 ScriptRegistrant<JMG_Utility_Change_Model_On_Timer> JMG_Utility_Change_Model_On_Timer_Registrant("JMG_Utility_Change_Model_On_Timer","Model=null:string,Time=0:float");
